const { is } = require('@creanet/js-type');
const SpecificQuery = require('./query.specific.class');
const { ValuesMixin, ReturningMixin } = require('../mixins');

class Insert extends ReturningMixin(ValuesMixin(SpecificQuery)) {
  get canExecute() {
    return is.not.null(this._values);
  }

  get query() {
    let query = `INSERT INTO ${this.table} ${this.valuesSQL}`;

    if (is.not.null(this._returning)) {
      query += ` RETURNING ${this.returningSQL}`;
    }

    return query;
  }
}

module.exports = Insert;
