/** @typedef {import('../database.class') Database}*/

const Query = require('./query.class');

/**
 * Generic query is not bound to any table
 *
 * @class GenericQuery
 * @extends {Query}
 */
class GenericQuery extends Query {
  /**
   * Creates an instance of GenericQuery.
   *
   * @param {Database} db
   * @param {String} query
   * @param {Object[]} [data=[]]
   */
  constructor(db, query, data = []) {
    super(db);

    this._query = query;
    this.data = data;
  }

  /**
   * Getter for query; can be overridden
   *
   * @readonly
   */
  get query() {
    return this._query;
  }
}

module.exports = GenericQuery;
