/** @typedef {import('../database.class') Database}*/

const Query = require('./query.class');

/**
 * Specific query is bound to a table.
 * This class is used as a parent class for other queries:
 * - SELECT
 * - INSERT
 * - DELETE
 * - UPDATE
 *
 * @class SpecificQuery
 * @extends {Query}
 */
class SpecificQuery extends Query {
  /**
   * Creates an instance of SpecificQuery.
   *
   * @param {Database} db
   * @param {String} table
   */
  constructor(db, table) {
    super(db);

    this.table = table;
  }
}

module.exports = SpecificQuery;
