const { is } = require('@creanet/js-type');
const SpecificQuery = require('./query.specific.class');
const {
  ColumnsMixin,
  LimitMixin,
  OffsetMixin,
  WhereMixin,
  OrderByMixin
} = require('../mixins');

class Select extends WhereMixin(
  OrderByMixin(OffsetMixin(LimitMixin(ColumnsMixin(SpecificQuery))))
) {
  get canExecute() {
    return is.not.null(this._columns);
  }

  get query() {
    return `SELECT ${this.columnsSQL} FROM ${this.table} ${this.whereSQL} ${this.orderBySQL} ${this.limitSQL} ${this.offsetSQL}`;
  }
}

module.exports = Select;
