const { is } = require('@creanet/js-type');

const OffsetMixin = C =>
  class OffsetMixin extends C {
    constructor() {
      super(...arguments);
      this._offset = null;
    }

    get offsetSQL() {
      if (is.null(this._offset)) {
        return '';
      }

      return `OFFSET ${this._offset}`;
    }

    /**
     * Sets the offset of query. Valid values are:
     * - `{number}` - maximal number of rows
     *
     * @param {number} offset
     */
    offset(offset) {
      if (is.not.numeric(offset)) {
        throw TypeError('offset is of invalid type');
      }

      this._offset = offset;

      return this;
    }
  };

module.exports = OffsetMixin;
