const { is, force } = require('@creanet/js-type');

const OrderByMixin = C =>
  class OrderByMixin extends C {
    constructor() {
      super(...arguments);
      this._orderBy = null;
    }

    get orderBySQL() {
      if (is.null(this._orderBy)) {
        return '';
      }

      // This assumes Object.entries(obj).length === 2
      const orderBy = this._orderBy
        .map(obj => Object.entries(obj)[0].join(' '))
        .join(',');

      return `ORDER BY ${orderBy}`;
    }

    orderBy(orderBy) {
      orderBy = force.array(orderBy);

      if (is.not.array(orderBy, 'keyValuePair')) {
        throw TypeError('orderBy is of invalid type');
      }

      this._orderBy = orderBy;

      return this;
    }
  };

module.exports = OrderByMixin;
