const { is, force } = require('@creanet/js-type');

const SetMixin = C =>
  class SetMixin extends C {
    constructor() {
      super(...arguments);
      this._set = null;
    }

    get setSQL() {
      const set = Object.entries(this._set)
        .map(([key, value]) => `${key}='${value}'`)
        .join(',');

      return `SET ${set}`;
    }

    /**
     * Sets the values of set. Valid values are:
     * - `{Object}` - one record with key:value pairs
     *
     * @param {Object|Array<Object>} values
     */
    set(set) {
      if (is.not.object(set)) {
        throw new TypeError('values is of invalid type');
      }

      this._set = set;

      return this;
    }
  };

module.exports = SetMixin;
